diff -Naur -X diff_ignore rsync-3.0.6_base/acls.c rsync/acls.c
--- rsync-3.0.6_base/acls.c	2009-04-10 19:09:39.000000000 -0400
+++ rsync/acls.c	2015-11-09 21:57:54.000000000 -0500
@@ -21,6 +21,11 @@
 
 #include "rsync.h"
 #include "lib/sysacls.h"
+#ifdef HAVE_OSX_ACLS
+// For _PATH_RSRCFORKSPEC
+#include <sys/paths.h>
+#include <uuid/uuid.h>
+#endif
 
 #ifdef SUPPORT_ACLS
 
@@ -31,6 +36,7 @@
 extern int orig_umask;
 extern int numeric_ids;
 extern int inc_recurse;
+extern int disable_acl_support;
 
 /* Flags used to indicate what items are being transmitted for an entry. */
 #define XMIT_USER_OBJ (1<<0)
@@ -53,7 +59,7 @@
 /* === ACL structures === */
 
 typedef struct {
-	id_t id;
+	unsigned char id[16];
 	uint32 access;
 } id_access;
 
@@ -117,7 +123,8 @@
 #ifdef ACLS_NEED_MASK
 	     + 4;
 #else
-	     + (racl->mask_obj != NO_ENTRY) + 3;
+//	     + (racl->mask_obj != NO_ENTRY) + 3;
+	     + (racl->mask_obj != NO_ENTRY);
 #endif
 }
 
@@ -176,7 +183,16 @@
 	ida1 = ial1->idas;
 	ida2 = ial2->idas;
 	for (; count--; ida1++, ida2++) {
+#ifdef HAVE_OSX_ACLS
+//rprintf(FINFO, "UUID1: %.32p, UUID2: %.32p\n", ida1->id, ida2->id);
+//char uuid_str1[37], uuid_str2[37];
+//if (ida1 != NULL) uuid_unparse(ida1->id, uuid_str1);
+//if (ida2 != NULL) uuid_unparse(ida2->id, uuid_str2);
+//rprintf(FINFO, "UUID1: %s, UUID2: %s\n", uuid_str1, uuid_str2);
+		if (ida1->access != ida2->access || uuid_compare(ida1->id, ida2->id) != 0)
+#else
 		if (ida1->access != ida2->access || ida1->id != ida2->id)
+#endif
 			return False;
 	}
 	return True;
@@ -266,9 +282,9 @@
 	     rc = sys_acl_get_entry(sacl, SMB_ACL_NEXT_ENTRY, &entry)) {
 		SMB_ACL_TAG_T tag_type;
 		uint32 access;
-		id_t g_u_id;
+		unsigned char *uu;
 		id_access *ida;
-		if ((rc = sys_acl_get_info(entry, &tag_type, &access, &g_u_id)) != 0) {
+		if ((rc = sys_acl_get_info(entry, &tag_type, &access, &uu)) != 0) {
 			errfun = "sys_acl_get_info";
 			break;
 		}
@@ -310,8 +326,12 @@
 			continue;
 		}
 		ida = EXPAND_ITEM_LIST(&temp_ida_list, id_access, -10);
-		ida->id = g_u_id;
+		int j;
+		for (j = 0; j < 16; j++)
+			ida->id[j] = uu != NULL ? uu[j] : 0;
 		ida->access = access;
+		if (uu)
+			acl_free(uu);
 	}
 	if (rc) {
 		rsyserr(FERROR_XFER, errno, "unpack_smb_acl: %s()", errfun);
@@ -389,7 +409,7 @@
 	SMB_ACL_ENTRY_T entry;
 
 	if (!(*smb_acl = sys_acl_init(calc_sacl_entries(racl)))) {
-		rsyserr(FERROR_XFER, errno, "pack_smb_acl: sys_acl_init()");
+		rsyserr(FERROR_XFER, errno, "pack_smb_acl: sys_acl_init(%d)", calc_sacl_entries(racl));
 		return False;
 	}
 
@@ -406,7 +426,11 @@
 		COE( sys_acl_create_entry,(smb_acl, &entry) );
 		COE( sys_acl_set_info,
 		    (entry,
+#ifdef HAVE_OSX_ACLS
+		     SMB_ACL_GROUP, // Ignored on OS X, see sys_acl_get_info()
+#else
 		     ida->access & NAME_IS_USER ? SMB_ACL_USER : SMB_ACL_GROUP,
+#endif
 		     ida->access & ~NAME_IS_USER, ida->id) );
 	}
 
@@ -434,7 +458,7 @@
 
 	COE( sys_acl_create_entry,(smb_acl, &entry) );
 	COE( sys_acl_set_info,(entry, SMB_ACL_OTHER, racl->other_obj & ~NO_ENTRY, 0) );
-#endif
+#endif // HAVE_OSX_ACLS
 
 #ifdef DEBUG
 	if (sys_acl_valid(*smb_acl) < 0)
@@ -506,10 +530,18 @@
 			if (!(ida = racl->names.idas = new_array(id_access, cnt)))
 				out_of_memory("get_rsync_acl");
 			racl->names.count = cnt;
+#ifdef HAVE_OSX_ACLS
+			for ( ; cnt--; ida++, bp += 16+4) {
+				//ida->id = IVAL(bp, 0);
+				memcpy(ida->id, bp, 16);
+				ida->access = IVAL(bp, 16);
+			}
+#else
 			for ( ; cnt--; ida++, bp += 4+4) {
 				ida->id = IVAL(bp, 0);
 				ida->access = IVAL(bp, 4);
 			}
+#endif
 		}
 		free(buf);
 		return 0;
@@ -517,19 +549,32 @@
 #endif
 
 	if ((sacl = sys_acl_get_file(fname, type)) != 0) {
+		if (verbose > 1)
+			fprintf(stderr, "Calling unpack_smb_acl() on %s\n", full_fname(fname));
+		errno = 0;
 		BOOL ok = unpack_smb_acl(sacl, racl);
 
 		sys_acl_free_acl(sacl);
 		if (!ok) {
+			rprintf(FERROR, "get_rsync_acl: unpack_smb_acl failed on %s [%s]\n", full_fname(fname), who_am_i());
 			return -1;
+//		} else if (S_ISDIR(mode)) {
+//			fprintf(stderr, "DEBUG: get_rsync_acl() retrieved a directory ACL for %s (%d entries):\n", full_fname(fname), racl->names.count);
+//			size_t count;
+//			id_access *ida;
+//			for (ida = racl->names.idas, count = racl->names.count; count; ida++, count--) {
+//				char uuid_str[37];
+//				uuid_unparse(ida->id, uuid_str);
+//				fprintf(stderr, "DEBUG: \tUUID: %s, access: 0x%.8X\n", uuid_str, ida->access);
+//			}
 		}
 	} else if (no_acl_syscall_error(errno)) {
 		/* ACLs are not supported, so pretend we have a basic ACL. */
 		if (type == SMB_ACL_TYPE_ACCESS)
 			rsync_acl_fake_perms(racl, mode);
 	} else {
-		rsyserr(FERROR_XFER, errno, "get_acl: sys_acl_get_file(%s, %s)",
-			fname, str_acl_type(type));
+		rsyserr(FERROR_XFER, errno, "get_rsync_acl: sys_acl_get_file(%s, %s) [%s]",
+			full_fname(fname), str_acl_type(type), who_am_i());
 		return -1;
 	}
 
@@ -570,6 +615,7 @@
 
 	for (ida = idal->idas; count--; ida++) {
 		uint32 xbits = ida->access << 2;
+#ifndef HAVE_OSX_ACLS
 		const char *name;
 		if (ida->access & NAME_IS_USER) {
 			xbits |= XFLAG_NAME_IS_USER;
@@ -584,6 +630,10 @@
 			write_buf(f, name, len);
 		} else
 			write_varint(f, xbits);
+#else
+		write_buf(f, (char *)ida->id, 16);
+		write_varint(f, xbits);
+#endif
 	}
 }
 
@@ -591,7 +641,8 @@
 			   item_list *racl_list, int f)
 {
 	int ndx = find_matching_rsync_acl(racl, type, racl_list);
-
+	//int ndx = -1;
+	
 	/* Send 0 (-1 + 1) to indicate that literal ACL data follows. */
 	write_varint(f, ndx + 1);
 
@@ -599,6 +650,8 @@
 		rsync_acl *new_racl = EXPAND_ITEM_LIST(racl_list, rsync_acl, 1000);
 		uchar flags = 0;
 
+//		fprintf(stderr, "DEBUG: send_rsync_acl() ndx: %lu, \n", racl_list->count-1);
+
 		if (racl->user_obj != NO_ENTRY)
 			flags |= XMIT_USER_OBJ;
 		if (racl->group_obj != NO_ENTRY)
@@ -640,6 +693,10 @@
 	/* Avoid sending values that can be inferred from other data. */
 	rsync_acl_strip_perms(sxp->acc_acl);
 
+	// DEBUG: Working on an issue related to uncache_duo_acls
+//	int ndx = find_matching_rsync_acl(sxp->acc_acl, SMB_ACL_TYPE_ACCESS, &access_acl_list);
+//	if (ndx < 0)
+//		fprintf(stderr, "DEBUG: [sender] New ACL found for %s [ndx: %zu]\n", fname, (&access_acl_list)->count);
 	send_rsync_acl(sxp->acc_acl, SMB_ACL_TYPE_ACCESS, &access_acl_list, f);
 
 	if (S_ISDIR(sxp->st.st_mode)) {
@@ -692,9 +749,18 @@
 
 	for (i = 0; i < count; i++) {
 		uchar has_name;
+#ifndef HAVE_OSX_ACLS
 		id_t id = read_varint(f);
+#else
+		unsigned char id[16];
+		read_buf(f, (char *)id, 16);
+//char uuid_str[37];
+//uuid_unparse(id, uuid_str);
+//rprintf(FINFO, "recv_ida_entries: UUID %s\n", uuid_str);
+#endif		
 		uint32 access = recv_acl_access(&has_name, f);
 
+#ifndef HAVE_OSX_ACLS
 		if (has_name) {
 			if (access & NAME_IS_USER)
 				id = recv_user_name(f, id);
@@ -707,8 +773,9 @@
 			if (inc_recurse && (!am_root || !numeric_ids))
 				id = match_gid(id, NULL);
 		}
+#endif		
 
-		ent->idas[i].id = id;
+		memcpy(ent->idas[i].id, id, 16);
 		ent->idas[i].access = access;
 		computed_mask_bits |= access;
 	}
@@ -724,8 +791,10 @@
 	int ndx = read_varint(f);
 
 	if (ndx < 0 || (size_t)ndx > racl_list->count) {
-		rprintf(FERROR_XFER, "recv_acl_index: %s ACL index %d > %d\n",
-			str_acl_type(type), ndx, (int)racl_list->count);
+		fprintf(stderr, "[%s]recv_rsync_acl: %s ACL index %d > %d\n",
+				who_am_i(), str_acl_type(type), ndx, (int)racl_list->count);
+		rprintf(FERROR_XFER, "[%s]recv_rsync_acl: %s ACL index %d > %d\n",
+			who_am_i(), str_acl_type(type), ndx, (int)racl_list->count);
 		exit_cleanup(RERR_STREAMIO);
 	}
 
@@ -749,6 +818,8 @@
 	if (flags & XMIT_NAME_LIST)
 		computed_mask_bits |= recv_ida_entries(&duo_item->racl.names, f);
 
+	//fprintf(stderr, "DEBUG: [%s]recv_rsync_acl() ndx: %lu\n", who_am_i(), racl_list->count-1);
+
 #ifdef HAVE_OSX_ACLS
 	/* If we received a superfluous mask, throw it away. */
 	duo_item->racl.mask_obj = NO_ENTRY;
@@ -765,7 +836,12 @@
 /* Receive the ACL info the sender has included for this file-list entry. */
 void receive_acl(struct file_struct *file, int f)
 {
+//	static int last_ndx = -1;
 	F_ACL(file) = recv_rsync_acl(&access_acl_list, SMB_ACL_TYPE_ACCESS, f);
+//	if (F_ACL(file) > last_ndx) {
+//		last_ndx = F_ACL(file);
+//		fprintf(stderr, "DEBUG: Received new ACL for %s [ndx: %d]\n", f_name(file, NULL), last_ndx);
+//	}
 
 	if (S_ISDIR(file->mode))
 		F_DIR_DEFACL(file) = recv_rsync_acl(&default_acl_list, SMB_ACL_TYPE_DEFAULT, f);
@@ -798,6 +874,7 @@
 
 	F_ACL(file) = cache_rsync_acl(sxp->acc_acl,
 				      SMB_ACL_TYPE_ACCESS, &access_acl_list);
+//	fprintf(stderr, "DEBUG: cache_tmp_acls, prior_access_count: %lu, access_acl_list.count: %lu [%s]\n", prior_access_count, access_acl_list.count, f_name(file, NULL));
 
 	if (S_ISDIR(sxp->st.st_mode)) {
 		if (prior_default_count == (size_t)-1)
@@ -826,6 +903,7 @@
 {
 	if (prior_access_count != (size_t)-1) {
 		uncache_duo_acls(&access_acl_list, prior_access_count);
+//		fprintf(stderr, "DEBUG: uncache_tmp_acls, new access_acl_list.count: %lu\n", access_acl_list.count);
 		prior_access_count = (size_t)-1;
 	}
 
@@ -927,8 +1005,8 @@
 #endif
 			rc = sys_acl_delete_def_file(fname);
 		if (rc < 0) {
-			rsyserr(FERROR_XFER, errno, "set_acl: sys_acl_delete_def_file(%s)",
-				fname);
+			rsyserr(FERROR_XFER, errno, "set_rsync_acl: sys_acl_delete_def_file(%s)",
+				full_fname(fname));
 			return -1;
 		}
 #ifdef SUPPORT_XATTRS
@@ -947,10 +1025,20 @@
 		if (cnt) {
 			char *bp = buf + 4*4;
 			id_access *ida = duo_item->racl.names.idas;
+#ifdef HAVE_OSX_ACLS
+			for ( ; cnt--; ida++, bp += 16+4) {
+				SIVAL(bp, 0, ida->id[0]);
+				SIVAL(bp, 4, ida->id[4]);
+				SIVAL(bp, 8, ida->id[8]);
+				SIVAL(bp, 12, ida->id[12]);
+				SIVAL(bp, 16, ida->access);
+			}
+#else
 			for ( ; cnt--; ida++, bp += 4+4) {
 				SIVAL(bp, 0, ida->id);
 				SIVAL(bp, 4, ida->access);
 			}
+#endif
 		}
 		rc = set_xattr_acl(fname, type == SMB_ACL_TYPE_ACCESS, buf, len);
 		free(buf);
@@ -958,9 +1046,22 @@
 #endif
 	} else {
 		mode_t cur_mode = sxp->st.st_mode;
+		if (verbose > 1)
+			fprintf(stderr, "Calling pack_smb_acl() on %s\n", full_fname(fname));
 		if (!duo_item->sacl
-		 && !pack_smb_acl(&duo_item->sacl, &duo_item->racl))
+		 && !pack_smb_acl(&duo_item->sacl, &duo_item->racl)) {
+			// BOMBICH
+			// Print out all ACEs associated with the current file
+			rprintf(FERROR, "set_rsync_acl: pack_smb_acl failed on %s\n", full_fname(fname));
+			int count = duo_item->racl.names.count;
+			int a;
+			for (a = 0; a < count; a++) {
+				char uuid_str[37];
+				uuid_unparse(duo_item->racl.names.idas[a].id, uuid_str);
+				rprintf(FERROR, "\tuuid: %s, access: %u\n", uuid_str, duo_item->racl.names.idas[a].access);
+			}
 			return -1;
+		}
 #ifdef HAVE_OSX_ACLS
 		mode = 0; /* eliminate compiler warning */
 #else
@@ -971,13 +1072,32 @@
 				return 0;
 		}
 #endif
-		if (sys_acl_set_file(fname, type, duo_item->sacl) < 0) {
-			rsyserr(FERROR_XFER, errno, "set_acl: sys_acl_set_file(%s, %s)",
-				fname, str_acl_type(type));
+//		if (S_ISDIR(sxp->st.st_mode)) {
+//			fprintf(stderr, "DEBUG: set_rsync_acl() setting a directory ACL on %s (%d entries):\n", full_fname(fname), duo_item->racl.names.count);
+//			size_t count;
+//			id_access *ida;
+//			for (ida = duo_item->racl.names.idas, count = duo_item->racl.names.count; count; ida++, count--) {
+//				char uuid_str[37];
+//				uuid_unparse(ida->id, uuid_str);
+//				fprintf(stderr, "DEBUG: \tUUID: %s, access: 0x%.8X\n", uuid_str, ida->access);
+//			}
+//		}
+		if (!disable_acl_support && sys_acl_set_file(fname, type, duo_item->sacl) < 0) {
+			rsyserr(FERROR_XFER, errno, "set_rsync_acl: sys_acl_set_file(%s, %s)",
+				full_fname(fname), str_acl_type(type));
+			if (duo_item->sacl) {
+				sys_acl_free_acl(duo_item->sacl);
+				duo_item->sacl = NULL;
+			}
 			return -1;
 		}
 		if (type == SMB_ACL_TYPE_ACCESS)
 			sxp->st.st_mode = cur_mode;
+
+		if (duo_item->sacl) {
+			sys_acl_free_acl(duo_item->sacl);
+			duo_item->sacl = NULL;
+		}
 	}
 
 	return 0;
@@ -1001,13 +1121,14 @@
 		errno = EROFS;
 		return -1;
 	}
-
+	
 	ndx = F_ACL(file);
+//	fprintf(stderr, "DEBUG: set_acl() ndx: %d, %s\n", ndx, fname);
 	if (ndx >= 0 && (size_t)ndx < access_acl_list.count) {
 		acl_duo *duo_item = access_acl_list.items;
 		duo_item += ndx;
 		eq = sxp->acc_acl
-		  && rsync_acl_equal_enough(sxp->acc_acl, &duo_item->racl, file->mode);
+			&& rsync_acl_equal_enough(sxp->acc_acl, &duo_item->racl, file->mode);
 		if (!eq) {
 			unchanged = 0;
 			if (!dry_run && fname
@@ -1042,6 +1163,7 @@
  * This is done in a single pass after receiving the whole file-list. */
 static void match_racl_ids(const item_list *racl_list)
 {
+#ifndef HAVE_OSX_ACLS
 	int list_cnt, name_cnt;
 	acl_duo *duo_item = racl_list->items;
 	for (list_cnt = racl_list->count; list_cnt--; duo_item++) {
@@ -1054,6 +1176,7 @@
 				ida->id = match_gid(ida->id, NULL);
 		}
 	}
+#endif
 }
 
 void match_acl_ids(void)
diff -Naur -X diff_ignore rsync-3.0.6_base/backup.c rsync/backup.c
--- rsync-3.0.6_base/backup.c	2009-06-18 17:30:50.000000000 -0400
+++ rsync/backup.c	2019-01-14 17:30:13.000000000 -0500
@@ -38,9 +38,12 @@
 extern char *backup_suffix_dels;
 extern char *backup_dir;
 extern char *backup_dir_dels;
-
+extern int logfile_format_has_i;
+extern int unsupported_fileflags;
 static int deleting;
 
+void strip_sip_flags(const char *fname);
+
 /* make a complete pathname for backup file */
 char *get_backup_name(const char *fname)
 {
@@ -54,7 +57,7 @@
 			return backup_dir_buf;
 	}
 
-	rprintf(FERROR, "backup filename too long\n");
+	rprintf(FERROR, "get_backup_name: backup filename too long (%s)\n", full_fname(fname));
 	return NULL;
 }
 
@@ -70,7 +73,7 @@
 			return backup_dir_dels_buf;
 	}
 
-	rprintf(FERROR, "delete filename too long\n");
+	rprintf(FERROR, "get_delete_name: delete filename too long (%s)\n", full_fname(fname));
 	return NULL;
 }
 
@@ -102,8 +105,8 @@
 		if (errno == ENOTDIR && do_unlink(fnamebak) == 0)
 			continue;
 
-		rsyserr(FERROR, rename_errno, "rename %s to backup %s",
-			fname, fnamebak);
+		rsyserr(FERROR, rename_errno, "make_simple_backup: rename %s to backup %s",
+			full_fname(fname), fnamebak);
 		errno = rename_errno;
 		return 0;
 	}
@@ -140,11 +143,11 @@
 			return -1;
 		if (*p == '/') {
 			*p = '\0';
-			if (mkdir_defmode(fbuf) == 0)
+			if (mkdir_defmode(fbuf) == 0 || errno == EEXIST) // We shouldn't ever get EEXIST (because all calls to make_bak_dir first require errno == ENOENT), but I've seen it happen
 				break;
 			if (errno != ENOENT) {
 				rsyserr(FERROR, errno,
-					"make_bak_dir mkdir %s failed",
+					"make_bak_dir: mkdir %s failed",
 					full_fname(fbuf));
 				return -1;
 			}
@@ -158,7 +161,7 @@
 			 * actual dir that the files are coming from. */
 			if (x_stat(rel, &sx.st, NULL) < 0) {
 				rsyserr(FERROR, errno,
-					"make_bak_dir stat %s failed",
+					"make_bak_dir: stat %s failed",
 					full_fname(rel));
 			} else {
 #ifdef SUPPORT_ACLS
@@ -176,29 +179,32 @@
 					free_acl(&sx);
 				}
 #endif
-#ifdef SUPPORT_XATTRS
-				if (preserve_xattrs) {
-					get_xattr(rel, &sx);
-					cache_tmp_xattr(file, &sx);
-					free_xattr(&sx);
-				}
-#endif
-				set_file_attrs(fbuf, file, NULL, NULL, 0);
+//#ifdef SUPPORT_XATTRS
+//				if (preserve_xattrs) {
+//					get_xattr(rel, &sx);
+//					if (verbose)
+//						fprintf(stderr, "DEBUG: make_bak_dir(): calling cache_tmp_xattr rel: %s, fbuf: %s\n", rel, fbuf);
+//					cache_tmp_xattr(file, &sx);
+//					free_xattr(&sx);
+//				}
+//#endif
+				// TODO: set_file_attrs() won't call set_xattr() if fnamecmp (fourth argument) is NULL
+				set_file_attrs(fbuf, file, NULL, NULL, ATTRS_STRIP_RESTRICTED);
 				unmake_file(file);
 #ifdef SUPPORT_ACLS
 				uncache_tmp_acls();
 #endif
-#ifdef SUPPORT_XATTRS
-				uncache_tmp_xattrs();
-#endif
+//#ifdef SUPPORT_XATTRS
+//				uncache_tmp_xattrs();
+//#endif
 			}
 		}
 		*p = '/';
 		p += strlen(p);
 		if (p == end)
 			break;
-		if (mkdir_defmode(fbuf) < 0) {
-			rsyserr(FERROR, errno, "make_bak_dir mkdir %s failed",
+		if (mkdir_defmode(fbuf) < 0 && errno != EEXIST) {
+			rsyserr(FERROR, errno, "make_bak_dir: mkdir %s failed",
 				full_fname(fbuf));
 			return -1;
 		}
@@ -211,6 +217,8 @@
 static int robust_move(const char *src, char *dst)
 {
 	if (robust_rename(src, dst, NULL, 0755) < 0) {
+		if (verbose && errno == ENOENT)
+			fprintf(stderr, "DEBUG: robust_move(%s, %s) failed: %d\n", src, dst, errno);
 		int save_errno = errno ? errno : EINVAL; /* 0 paranoia */
 		if (errno == ENOENT && make_bak_dir(dst) == 0) {
 			if (robust_rename(src, dst, NULL, 0755) < 0)
@@ -235,8 +243,8 @@
 	struct file_struct *file;
 	char *buf;
 	int save_preserve_xattrs = preserve_xattrs;
+	int save_preserve_acls = preserve_acls;
 	int kept = 0;
-	int ret_code;
 
 	/* return if no file to keep */
 	if (x_lstat(fname, &sx.st, NULL) < 0)
@@ -251,32 +259,36 @@
 	if (!(file = make_file(fname, NULL, NULL, 0, NO_FILTERS)))
 		return 1; /* the file could have disappeared */
 
+	// BOMBICH: Some files are just noise when they're archived, so we exclude them here
+	// Ultimately it would be preferable to have a specific filter for items that
+	// should not be archived
+	// We'll have to come up with a better way to avoid these empty-looking folders
+	// http://help.bombich.com/discussions/problems/13468-help-an-error-occurred-while-ccc-was-modifying-this-items-filesystem-entry-on-the-destination
+//	if (strncmp(file->basename, ".DS_Store", 9) == 0)
+//		return 1;
+	
 	buf = deleting ? get_delete_name(fname) : get_backup_name(fname);
 	if (!buf) {
 		unmake_file(file);
-#ifdef SUPPORT_ACLS
-		uncache_tmp_acls();
-#endif
-#ifdef SUPPORT_XATTRS
-		uncache_tmp_xattrs();
-#endif
 		return 0;
 	}
 
-#ifdef SUPPORT_ACLS
-	if (preserve_acls && !S_ISLNK(file->mode)) {
-		get_acl(fname, &sx);
-		cache_tmp_acl(file, &sx);
-		free_acl(&sx);
-	}
-#endif
-#ifdef SUPPORT_XATTRS
-	if (preserve_xattrs) {
-		get_xattr(fname, &sx);
-		cache_tmp_xattr(file, &sx);
-		free_xattr(&sx);
-	}
-#endif
+//#ifdef SUPPORT_ACLS
+//	if (preserve_acls && !S_ISLNK(file->mode)) {
+//		get_acl(fname, &sx);
+//		cache_tmp_acl(file, &sx);
+//		free_acl(&sx);
+//	}
+//#endif
+//#ifdef SUPPORT_XATTRS
+//	if (preserve_xattrs) {
+//		get_xattr(fname, &sx);
+//		if (verbose)
+//			fprintf(stderr, "DEBUG: keep_backup(): calling cache_tmp_xattr |%s\n", buf);
+//		cache_tmp_xattr(file, &sx); // Why do we get xattrs at all if we're going to set preserve_xattrs to 0 before calling set_file_attrs()?
+//		free_xattr(&sx);
+//	}
+//#endif
 
 	/* Check to see if this is a device file, or link */
 	if ((am_root && preserve_devices && IS_DEVICE(file->mode))
@@ -285,6 +297,8 @@
 		do_unlink(buf);
 		if (do_mknod(buf, file->mode, sx.st.st_rdev) < 0) {
 			save_errno = errno ? errno : EINVAL; /* 0 paranoia */
+			if (verbose)
+				fprintf(stderr, "DEBUG: keep_backup: do_mknod() failed: %d |%s\n", errno, buf);
 			if (errno == ENOENT && make_bak_dir(buf) == 0) {
 				if (do_mknod(buf, file->mode, sx.st.st_rdev) < 0)
 					save_errno = errno ? errno : save_errno;
@@ -292,8 +306,8 @@
 					save_errno = 0;
 			}
 			if (save_errno) {
-				rsyserr(FERROR, save_errno, "mknod %s failed",
-					full_fname(buf));
+				//rsyserr(FERROR, save_errno, "mknod %s failed", full_fname(buf));
+				kept = 0; // I'm going to ignore this error, devices aren't important enough to spew errors.
 			}
 		} else
 			save_errno = 0;
@@ -301,30 +315,21 @@
 			rprintf(FINFO, "make_backup: DEVICE %s successful.\n",
 				fname);
 		}
-		kept = 1;
+		if (save_errno == 0)
+			kept = 1;
 		do_unlink(fname);
 	}
 
+	// BOMBICH
 	if (!kept && S_ISDIR(file->mode)) {
-		/* make an empty directory */
-		if (do_mkdir(buf, file->mode) < 0) {
-			int save_errno = errno ? errno : EINVAL; /* 0 paranoia */
-			if (errno == ENOENT && make_bak_dir(buf) == 0) {
-				if (do_mkdir(buf, file->mode) < 0)
-					save_errno = errno ? errno : save_errno;
-				else
-					save_errno = 0;
-			}
-			if (save_errno) {
-				rsyserr(FINFO, save_errno, "mkdir %s failed",
-					full_fname(buf));
-			}
-		}
-
-		ret_code = do_rmdir(fname);
-		if (verbose > 2) {
-			rprintf(FINFO, "make_backup: RMDIR %s returns %i\n",
-				full_fname(fname), ret_code);
+		if (verbose)
+			fprintf(stderr, "DEBUG: keep_backup(): calling robust_move(%s --> %s)\n", fname, buf);
+		if (robust_move(fname, buf) != 0) {
+			rsyserr(FERROR, errno, "keep_backup: failed (directory): %s -> \"%s\"",
+			full_fname(fname), buf);
+		} else if (!(unsupported_fileflags & (SF_RESTRICTED|SF_NOUNLINK))) {
+			// Strip SIP flags
+			strip_sip_flags(buf);
 		}
 		kept = 1;
 	}
@@ -333,7 +338,7 @@
 	if (!kept && preserve_links && S_ISLNK(file->mode)) {
 		const char *sl = F_SYMLINK(file);
 		if (safe_symlinks && unsafe_symlink(sl, fname)) {
-			if (verbose) {
+			if (verbose > 1) {
 				rprintf(FINFO, "ignoring unsafe symlink %s -> %s\n",
 					full_fname(buf), sl);
 			}
@@ -341,6 +346,8 @@
 		} else {
 			do_unlink(buf);
 			if (do_symlink(sl, buf) < 0) {
+				if (verbose)
+					fprintf(stderr, "DEBUG: keep_backup: do_symlink(%s, %s) failed: %d\n", sl, buf, errno);
 				int save_errno = errno ? errno : EINVAL; /* 0 paranoia */
 				if (errno == ENOENT && make_bak_dir(buf) == 0) {
 					if (do_symlink(sl, buf) < 0)
@@ -349,58 +356,122 @@
 						save_errno = 0;
 				}
 				if (save_errno) {
-					rsyserr(FERROR, save_errno, "link %s -> \"%s\"",
-						full_fname(buf), sl);
+					if (strlen(sl) > 0) {
+						rsyserr(FERROR, save_errno, "keep_backup: link %s -> \"%s\"",
+								full_fname(buf), sl);
+					} else {
+						fprintf(stderr, "DEBUG: keep_backup: do_symlink(%s, %s) failed: %d\n", sl, buf, save_errno);
+						kept = -2;
+					}
 				}
 			}
 			do_unlink(fname);
-			kept = 1;
+			kept++;
 		}
 	}
 #endif
 
 	if (!kept && !S_ISREG(file->mode)) {
-		rprintf(FINFO, "make_bak: skipping non-regular file %s\n",
+		rprintf(FERROR, "make_bak: skipping non-regular file %s\n",
 			fname);
 		unmake_file(file);
-#ifdef SUPPORT_ACLS
-		uncache_tmp_acls();
-#endif
-#ifdef SUPPORT_XATTRS
-		uncache_tmp_xattrs();
-#endif
+//#ifdef SUPPORT_ACLS
+//		uncache_tmp_acls();
+//#endif
+//#ifdef SUPPORT_XATTRS
+//		uncache_tmp_xattrs();
+//#endif
 		return 1;
 	}
 
 	/* move to keep tree if a file */
 	if (!kept) {
-		if (robust_move(fname, buf) != 0) {
-			rsyserr(FERROR, errno, "keep_backup failed: %s -> \"%s\"",
+		if (verbose > 1)
+			fprintf(stderr, "keep_backup(): calling robust_move(%s --> %s)\n", fname, buf);
+		kept = robust_move(fname, buf) == 0;
+		if (!kept) {
+			rsyserr(FERROR, errno, "keep_backup: failed (file): %s -> \"%s\"",
 				full_fname(fname), buf);
 		} else if (sx.st.st_nlink > 1) {
 			/* If someone has hard-linked the file into the backup
 			 * dir, rename() might return success but do nothing! */
+			 if (verbose > 1)
+				fprintf(stderr, "keep_backup(): calling robust_unlink on %s because link count is > 1\n", full_fname(fname));
 			robust_unlink(fname); /* Just in case... */
 		}
 	}
+	
+	// OK, so we aren't planning to re-apply the xattrs on this file (we're only moving it) --
+	// why did we bother collecting and caching its xattrs in the first place?
 	preserve_xattrs = 0;
-	set_file_attrs(buf, file, NULL, fname, 0);
+	preserve_acls = 0;
+	if (kept > 0)
+		set_file_attrs(buf, file, NULL, fname, ATTRS_STRIP_RESTRICTED);
 	preserve_xattrs = save_preserve_xattrs;
+	preserve_acls = save_preserve_acls;
+
+	if (logfile_format_has_i)
+		log_non_transfer(fname, S_ISDIR(file->mode) ? S_IFDIR : S_IFREG, ITEM_ARCHIVED);
+
 	unmake_file(file);
-#ifdef SUPPORT_ACLS
-	uncache_tmp_acls();
-#endif
-#ifdef SUPPORT_XATTRS
-	uncache_tmp_xattrs();
-#endif
+//#ifdef SUPPORT_ACLS
+//	uncache_tmp_acls();
+//#endif
+//#ifdef SUPPORT_XATTRS
+//	uncache_tmp_xattrs();
+//#endif
 
 	if (verbose > 1) {
 		rprintf(FINFO, "backed up %s to %s\n",
 			fname, buf);
 	}
+
 	return 1;
 }
 
+void strip_sip_flags(const char *dirname)
+{
+	DIR *dir;
+	struct dirent *ent;
+	dir = opendir(dirname);
+	if (dir != NULL) {
+		while((ent = readdir(dir)) != NULL) {
+			BOOL skip = (ent->d_namlen == 1 && ent->d_name[0] == '.') || (ent->d_namlen == 2 && ent->d_name[0] == '.' && ent->d_name[1] == '.');
+			if (!skip) {
+				char *fileName = ent->d_name;
+				char *fullPath;
+				fullPath = malloc(MAXPATHLEN);
+				snprintf(fullPath, MAXPATHLEN, "%s/%s", dirname, fileName);
+
+				struct stat f;
+				int ret = lstat(fullPath, &f);
+				if (ret != 0) {
+					fprintf(stderr, "DEBUG: strip_sip_flags: Failed to stat %s: %d\n", fullPath, errno);
+				} else {
+					int fileflags = f.st_flags;
+					int newflags = fileflags & ~(SF_RESTRICTED|SF_NOUNLINK);
+					if (fileflags != newflags) {
+						if (S_ISLNK(f.st_mode)) {
+							ret = lchflags(fullPath, newflags);
+						} else {
+							ret = chflags(fullPath, newflags);
+						}
+						if (ret != 0)
+							fprintf(stderr, "DEBUG: strip_sip_flags: Failed to strip SIP flags from %s: %d\n", fullPath, errno);
+					}
+					
+					if (S_ISDIR(f.st_mode))
+						strip_sip_flags(fullPath);
+				}
+				free(fullPath);
+			}
+		}
+		closedir(dir);
+	} else {
+		fprintf(stderr, "DEBUG: strip_sip_flags: Failed to open %s: %d\n", dirname, errno);
+	}
+}
+
 
 /* main backup switch routine */
 int make_backup(const char *fname)
diff -Naur -X diff_ignore rsync-3.0.6_base/byteorder.h rsync/byteorder.h
--- rsync-3.0.6_base/byteorder.h	2008-03-01 15:01:41.000000000 -0500
+++ rsync/byteorder.h	2016-12-28 22:47:47.000000000 -0500
@@ -18,10 +18,9 @@
  * with this program; if not, visit the http://fsf.org website.
  */
 
-#undef CAREFUL_ALIGNMENT
-
 /* We know that the x86 can handle misalignment and has the same
  * byte order (LSB-first) as the 32-bit numbers we transmit. */
+/*
 #ifdef __i386__
 #define CAREFUL_ALIGNMENT 0
 #endif
@@ -29,6 +28,8 @@
 #ifndef CAREFUL_ALIGNMENT
 #define CAREFUL_ALIGNMENT 1
 #endif
+*/
+#define CAREFUL_ALIGNMENT 0
 
 #define CVAL(buf,pos) (((unsigned char *)(buf))[pos])
 #define UVAL(buf,pos) ((uint32)CVAL(buf,pos))
@@ -40,6 +41,9 @@
 #define SSVALX(buf,pos,val) (CVAL(buf,pos)=(val)&0xFF,CVAL(buf,pos+1)=(val)>>8)
 #define SIVALX(buf,pos,val) (SSVALX(buf,pos,val&0xFFFF),SSVALX(buf,pos+2,val>>16))
 #define SIVAL(buf,pos,val) SIVALX((buf),(pos),((uint32)(val)))
+
+#define IVALu(buf,pos) IVAL(buf,pos)
+#define SIVALu(buf,pos,val) SIVAL(buf,pos,val)
 #else
 /* this handles things for architectures like the 386 that can handle
    alignment errors */
@@ -47,6 +51,72 @@
    WARNING: This section is dependent on the length of int32
    being correct. set CAREFUL_ALIGNMENT if it is not.
 */
+# ifdef AVOID_BYTEORDER_INLINE
+
 #define IVAL(buf,pos) (*(uint32 *)((char *)(buf) + (pos)))
 #define SIVAL(buf,pos,val) IVAL(buf,pos)=((uint32)(val))
+
+#define IVALu(buf,pos) IVAL(buf,pos)
+#define SIVALu(buf,pos,val) SIVAL(buf,pos,val)
+
+# else /* !AVOID_BYTEORDER_INLINE */
+
+static inline uint32
+IVALu(const uchar *buf, int pos)
+{
+	union {
+		const uchar *b;
+		const uint32 *num;
+	} u;
+	u.b = buf + pos;
+	return *u.num;
+}
+
+static inline void
+SIVALu(uchar *buf, int pos, uint32 val)
+{
+	union {
+		uchar *b;
+		uint32 *num;
+	} u;
+	u.b = buf + pos;
+	*u.num = val;
+}
+
+static inline uint32
+IVAL(const char *buf, int pos)
+{
+	return IVALu((uchar*)buf, pos);
+}
+
+static inline void
+SIVAL(char *buf, int pos, uint32 val)
+{
+	SIVALu((uchar*)buf, pos, val);
+}
+
+static inline int64
+IVAL64(const char *buf, int pos)
+{
+	union {
+		const char *b;
+		const int64 *num;
+	} u;
+	u.b = buf + pos;
+	return *u.num;
+}
+
+static inline void
+SIVAL64(char *buf, int pos, int64 val)
+{
+	union {
+		char *b;
+		int64 *num;
+	} u;
+	u.b = buf + pos;
+	*u.num = val;
+}
+
+# endif /* !AVOID_BYTEORDER_INLINE */
+
 #endif
diff -Naur -X diff_ignore rsync-3.0.6_base/checksum.c rsync/checksum.c
--- rsync-3.0.6_base/checksum.c	2009-01-17 16:41:35.000000000 -0500
+++ rsync/checksum.c	2018-09-17 15:35:28.000000000 -0400
@@ -26,6 +26,8 @@
 
 int csum_length = SHORT_SUM_LENGTH; /* initial value */
 
+// BOMBICH
+static time_t last_hb = 0;
 /*
   a simple 32 bit checksum that can be upadted from either end
   (inspired by Mark Adler's Adler-32 checksum)
@@ -58,7 +60,7 @@
 		md5_begin(&m);
 		md5_update(&m, (uchar *)buf, len);
 		if (checksum_seed) {
-			SIVAL(seedbuf, 0, checksum_seed);
+			SIVALu(seedbuf, 0, checksum_seed);
 			md5_update(&m, seedbuf, 4);
 		}
 		md5_result(&m, (uchar *)sum);
@@ -111,8 +113,11 @@
 	memset(sum, 0, MAX_DIGEST_LEN);
 
 	fd = do_open(fname, O_RDONLY, 0);
-	if (fd == -1)
+	if (fd == -1) {
+		if (errno != ENOENT)
+			fprintf(stderr, "[%s] file_checksum: Failed to open %s for reading: %s (%d)\n", who_am_i(), full_fname(fname), strerror(errno), errno);
 		return;
+	}
 
 	buf = map_file(fd, size, MAX_MAP_SIZE, CSUM_CHUNK);
 
@@ -120,6 +125,21 @@
 		md5_begin(&m);
 
 		for (i = 0; i + CSUM_CHUNK <= len; i += CSUM_CHUNK) {
+#ifdef PARSEABLE_OUTPUT
+			if ((0)) {
+				if (last_hb == 0)
+					last_hb = time(NULL);
+				time_t now = time(NULL);
+				if (now - last_hb >= 5) {
+					last_hb = now;
+					rprintf(FINFO, "S;;;CHECKSUM;;;LEN;;;%lld;;;CF;;;%s\n", i + CSUM_CHUNK, fname);
+				}
+			} else {
+				if (((i + CSUM_CHUNK) % (1024*1024*100)) == 0) { // every 100MB
+					rprintf(FINFO, "S;;;CHECKSUM;;;LEN;;;%lld;;;CF;;;%s\n", i + CSUM_CHUNK, fname);
+				}
+			}
+#endif
 			md5_update(&m, (uchar *)map_ptr(buf, i, CSUM_CHUNK),
 				   CSUM_CHUNK);
 		}
diff -Naur -X diff_ignore rsync-3.0.6_base/cleanup.c rsync/cleanup.c
--- rsync-3.0.6_base/cleanup.c	2009-01-17 16:41:35.000000000 -0500
+++ rsync/cleanup.c	2015-11-09 21:57:54.000000000 -0500
@@ -99,6 +99,10 @@
 
 	SIGACTION(SIGUSR1, SIG_IGN);
 	SIGACTION(SIGUSR2, SIG_IGN);
+	fprintf(stderr, "DEBUG: exit_cleanup[%s]: cleanup_child_pid: %d. Error code: %d at %s:%d\n", who_am_i(), cleanup_child_pid, code, file, line);
+	if (code == RERR_SIGNAL)
+		fprintf(stderr, "Terminated by SIGINT, SIGTERM, or SIGHUP\n");
+	fflush(stderr);
 
 	if (exit_code) /* Preserve first error code when recursing. */
 		code = exit_code;
@@ -127,8 +131,10 @@
 		if (cleanup_child_pid != -1) {
 			int status;
 			int pid = wait_process(cleanup_child_pid, &status, WNOHANG);
+			//fprintf(stderr, "DEBUG: exit_cleanup[%s]: pid: %d\n", who_am_i(), pid);
 			if (pid == cleanup_child_pid) {
 				status = WEXITSTATUS(status);
+				//fprintf(stderr, "DEBUG: exit_cleanup[%s]: status: %d\n", who_am_i(), status);
 				if (status > code)
 					code = exit_code = status;
 			}
diff -Naur -X diff_ignore rsync-3.0.6_base/compat.c rsync/compat.c
--- rsync-3.0.6_base/compat.c	2009-06-18 17:30:46.000000000 -0400
+++ rsync/compat.c	2016-11-17 22:38:19.000000000 -0500
@@ -49,6 +49,7 @@
 extern int preserve_fileflags;
 extern int preserve_acls;
 extern int preserve_xattrs;
+extern int preserve_hfs_compression;
 extern int need_messages_from_generator;
 extern int delete_mode, delete_before, delete_during, delete_after;
 extern char *shell_cmd;
@@ -76,6 +77,7 @@
 #define CF_INC_RECURSE	 (1<<0)
 #define CF_SYMLINK_TIMES (1<<1)
 #define CF_SYMLINK_ICONV (1<<2)
+#define CF_HFS_COMPRESSION (1<<3)
 
 static const char *client_info;
 
@@ -262,6 +264,10 @@
 #ifdef ICONV_OPTION
 			compat_flags |= CF_SYMLINK_ICONV;
 #endif
+#ifdef SUPPORT_HFS_COMPRESSION
+			if (preserve_hfs_compression)
+				compat_flags |= CF_HFS_COMPRESSION;
+#endif
 			write_byte(f_out, compat_flags);
 		} else
 			compat_flags = read_byte(f_in);
@@ -271,6 +277,12 @@
 			receiver_symlink_times = am_server
 			    ? strchr(client_info, 'L') != NULL
 			    : !!(compat_flags & CF_SYMLINK_TIMES);
+#ifdef SUPPORT_HFS_COMPRESSION
+			// CF_HFS_COMPRESSION will be set on the remote side as long as preserve_hfs_compression > 1
+			if (preserve_hfs_compression && !(compat_flags & CF_HFS_COMPRESSION))
+				preserve_hfs_compression = 0;
+
+#endif
 		}
 #if defined HAVE_LUTIMES && defined HAVE_UTIMES
 		else
